<?php
 echo '<?xml version="1.0" encoding="utf-8"?>';
 
 ?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta content="text/html; charset=utf-8" http-equiv="Content-Type">
<meta content="ja" http-equiv="Content-Language">
</head>
<body>
<?php
date_default_timezone_set('Asia/Tokyo');
// -------------------------------------------------------------
// 初期設定
$URL_RSS = "http://weather.livedoor.com/forecast/rss/13/63.xml";
/* $URL_RSS  = "http://weather.livedoor.com/forecast/rss/area/190010.xml"; */

$CACHE_RSS    = "cache_rss.xml";
$CACHE_PERIOD = 60 * 60 * 6; // 6時間
// パラメータから表示したい月を得る
$year  = isset($_GET['y']) ? $_GET['y'] : date("Y");
$month = isset($_GET['m']) ? $_GET['m'] : date("m");
//
// 天気予報の取得処理
$tenki = array();
// 頻繁にRSSにアクセスしないようキャッシュを確認する
$flag_read = TRUE;
if (file_exists($CACHE_RSS)) {
    $mt = filemtime($CACHE_RSS); // 保存日時を取得する
    if ((time() - $mt) < $CACHE_PERIOD) { // 日時を比較する
        $flag_read = FALSE;
    }
}
if ($flag_read) {
    $tmp = file_get_contents($URL_RSS); // URLから取り込んで保存する
    file_put_contents($CACHE_RSS, $tmp);
}
// XML を読み込む
$xml = simplexml_load_file($CACHE_RSS);
foreach($xml->channel->item as $row) {
    $link  = $row->image->link;
    $icon = $row->image->url;
    // URLから天気予報の日付を取得する
    if (preg_match('#\?r\=rss(\d+)#', $link, $match)) {
        $date = $match[1];
        $tenki[$date] = $icon;
    }
}
// -------------------------------------------------------------
// カレンダーの表示処理
// 翌月と前月のリンクを作る処理
$prev = mktime(0,0,0,$month-1,1,$year);
$prev_m = date("m",$prev);
$prev_y = date("Y",$prev);
$next = mktime(0,0,0,$month+1,1,$year);
$next_m = date("m",$next);
$next_y = date("Y",$next);
// タイトルとリンクを表示
echo "<center>";
echo "<h3><a href='?y=$prev_y&m=$prev_m'>前月</a>&nbsp;&nbsp;";
$month = ltrim($month, '0');
echo "[$year 年 $month 月]";
echo "&nbsp;&nbsp;<a href='?y=$next_y&m=$next_m'>次月</a></h3>";
// 1日の曜日を取得
$h24 = 24 * 60 * 60;
$cur = mktime(0,0,0,$month,1,$year);
$week = date("w", $cur);
$cur -= ($week * $h24); // カレンダーの左上の日付を得る

?>
<table border=2>
<tr align="center">
		<td><font  color="red"><strong>日</strong></font></td>
		<td>月</td><td>火</td><td>水</td><td>木</td><td>金</td>
		<td><font color="blue"><strong>土</strong></font></td>
	</tr>
<?php

//現在日の判定カウンタ
$cnt = 0;
for ($i = 0; $i < 42; $i++) {
    if ($i % 7 == 0) { echo "<tr align=\"center\">"; }
    $day = date("d", $cur);
    $mon = date("m", $cur);
    //配列$tenkiが、空値の場合にNULLを代入
    if(empty($tenki["$year$mon$day"])){$tenki["$year$mon$day"] = null; }
    $icon = $tenki["$year$mon$day"];
    if ($month != $mon) { $day = "&nbsp;"; }
    $cur += $h24;
    if (!$icon) { $icon = "blank.gif"; }
    //先頭の0を削除
    $day = ltrim($day, '0');
    if($icon != "blank.gif" and $cnt == 0){
     echo "<td cellspacing=\"10\" bordercolor=\"lightbrown\" bgcolor=\"lightbrown\">";
     $cnt++;
    }
    else { echo "<td>"; }
    if ($i % 7 == 0){ echo "<font color=\"red\"><strong>";}
    if ($i % 7 == 6){ echo "<font color=\"blue\"><strong>";}
	echo "$day<br/>";
    if ($i % 7 == 0 or $i % 7 == 6){ echo "</strong></font>";}
    echo "<img src='$icon' height=31 width=50 /></td>";
    if ($i % 7 == 6) { echo "</tr>"; }
}
?>

</table>
</body>
</html>

